package kombinatiot;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;
import java.util.regex.Pattern;

/**
 * Tarkistetaan onko tiedostosta input.txt saatava syte sellaisia jonoja,
 * jotka tsmvt annettuun RegExpiin.
 * Jonoja pit olla tsmlleen n kappaletta ja niiden pit olla erilaisia
 * keskenn. 
 * Tarkoitettu kytettvksi lhinn TIMin kanssa, joka muuttaa
 * vertailuarvoja tarpeen mukaan.
 * 
 * @author vesal
 * @version 18.1.2015
 *
 */
public class RegInputTarkistaja {

    private static int MAARA = 5; // MUUTAMAARA - montako jonoa pit antaa
    private static String REGEXP = ".*"; // MUUTAREGEXP - tutkittava regexp, jota vastaan input.txt verrataan
    private static String REGEXPRAJ = ".*"; // MUUTARAJOITEREGEXP - rajoite jolla voidaan rajoittaa sallitut merkit
    private static int MIN=0, MAX=5000; // MUUTAPITUUSRAJAT - mill vlill jonon pituuden tulee olla
    private static boolean odotettuTulos = true; // MUUTATULOS - halutaanko match vai ei-match
    
    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
        Path path = Paths.get("", "input.txt");
        int n = 0, i = 0;
        try {
            List<String> lines = Files.readAllLines(path);
            HashMap<String, String> tutkitut = new HashMap<String, String>();
            for (String s : lines) {
                s = s.trim();
                if (s.equals("")) continue;
                if ( tutkitut.containsKey(s) ) continue;
                tutkitut.put(s, s);
                i++;
                boolean match = Pattern.matches(REGEXP, s);
                boolean match2 = Pattern.matches(REGEXPRAJ, s);
                String tulos = match ? "hyvksyy" : "hylk";
                String ok = "vrin";
                if ( s.length() < MIN || MAX < s.length() ) ok ="vrn pituinen";
                else if ( !match2 ) ok = "ei tyt rajoitetta "+ REGEXPRAJ;
                else if (match == odotettuTulos ) {
                    ok = "OK";
                    n++;
                }
                System.out.println(i + " " + s + ": " + tulos + ", " + ok);
            }
        } catch (IOException e) {
            System.out.println("Talleta ensin tiedosto!");
        }
        
        if (n == MAARA)
            System.out.printf("Oli %d oikein.", MAARA);
        else
            System.out.printf("Oikeita oli %d/%d.", n, MAARA);
        if (i != MAARA)
            System.out.printf("\nOli %d jonoa, piti olla %d eri jonoa.", i, MAARA);
    }

}